#!/sbin/sh

mkdir /tmp/ramdisk
cp /tmp/boot.img-ramdisk.gz /tmp/ramdisk/
cd /tmp/ramdisk/
/tmp/busybox gunzip -c /tmp/ramdisk/boot.img-ramdisk.gz | /tmp/busybox cpio -i
rm /tmp/ramdisk/boot.img-ramdisk.gz
rm /tmp/boot.img-ramdisk.gz

#Don't force encryption
if  grep -qr forceencrypt /tmp/ramdisk/fstab.shamu; then
   sed -i "s/forceencrypt/encryptable/" /tmp/ramdisk/fstab.shamu
fi
if  grep -qr forcefdeorfbe /tmp/ramdisk/fstab.shamu; then
   sed -i "s/forcefdeorfbe/encryptable/" /tmp/ramdisk/fstab.shamu
fi

#Disable dm_verity
if  grep -qr verify=/dev/block/platform/msm_sdcc.1/by-name/metadata /tmp/ramdisk/fstab.shamu; then
   sed -i "s/\,verify\=\/dev\/block\/platform\/msm_sdcc\.1\/by\-name\/metadata//" /tmp/ramdisk/fstab.shamu
fi
rm /tmp/ramdisk/verity_key

#F2FS on /data
if  ! grep -q '/data.*f2fs' /tmp/ramdisk/fstab.shamu; then
   sed -i 's@.*by-name/userdata.*@//dev/block/platform/msm_sdcc.1/by-name/userdata     /data           f2fs    rw,nosuid,nodev,noatime,nodiratime,inline_xattr                 wait,encryptable=/dev/block/platform/msm_sdcc.1/by-name/metadata\n&@' /tmp/ramdisk/fstab.shamu
fi

#F2FS on /cache
if  ! grep -q '/cache.*f2fs' /tmp/ramdisk/fstab.shamu; then
   sed -i 's@.*by-name/cache.*@//dev/block/platform/msm_sdcc.1/by-name/cache        /cache          f2fs    rw,nosuid,nodev,noatime,nodiratime,inline_xattr                 wait,check\n&@' /tmp/ramdisk/fstab.shamu
fi

#Disable mpdecision
if [ $(grep -c "service mpdecision" /tmp/ramdisk/init.shamu.rc) == 1 ]; then
   sed -i "/service mpdecision/{N;N;N;d}" /tmp/ramdisk/init.shamu.rc
fi

#Start elementalx script
if [ $(grep -c "import /init.elementalx.rc" /tmp/ramdisk/init.rc) == 0 ]; then
   sed -i "/import \/init\.environ\.rc/aimport /init.elementalx.rc" /tmp/ramdisk/init.rc
fi

#copy elementalx scripts
cp /tmp/init.elementalx.rc /tmp/ramdisk/init.elementalx.rc
chmod 0750 /tmp/ramdisk/init.elementalx.rc

#enable elementalx governor
if  ! grep -qr "scaling_governor elementalx" /tmp/ramdisk/init.shamu.power.rc; then
    echo "" >> /tmp/ramdisk/init.shamu.power.rc
    echo "    write /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor elementalx" >> /tmp/ramdisk/init.shamu.power.rc
    echo "    write /sys/devices/system/cpu/cpu1/cpufreq/scaling_governor elementalx" >> /tmp/ramdisk/init.shamu.power.rc
    echo "    write /sys/devices/system/cpu/cpu2/cpufreq/scaling_governor elementalx" >> /tmp/ramdisk/init.shamu.power.rc
    echo "    write /sys/devices/system/cpu/cpu3/cpufreq/scaling_governor elementalx" >> /tmp/ramdisk/init.shamu.power.rc
fi

#set input boost ms
sed -i "/write \/sys\/module\/cpu_boost\/parameters\/input_boost_ms/c\    write \/sys/module\/cpu_boost\/parameters\/input_boost_ms 800"  /tmp/ramdisk/init.shamu.power.rc

find . | cpio -o -H newc | gzip > /tmp/boot.img-ramdisk.gz
rm -r /tmp/ramdisk

