#!/sbin/sh

#Build config file
CONFIGFILE="/tmp/init.elementalx.rc"
BACKUP="/sdcard/.elementalx.backup"

echo "on boot" >> $CONFIGFILE
echo "" >> $CONFIGFILE

#S2W
SR=`grep "item.1.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
SL=`grep "item.1.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
SU=`grep "item.1.3" /tmp/aroma/gest.prop | cut -d '=' -f2`
SD=`grep "item.1.4" /tmp/aroma/gest.prop | cut -d '=' -f2`

if [ $SL = 1 ]; then
  SL=2
fi
if [ $SU == 1 ]; then
  SU=4
fi
if [ $SD == 1 ]; then
  SD=8
fi  

S2W=$(( SL + SR + SU + SD ))
echo "write /sys/android_touch/sweep2wake " $S2W >> $CONFIGFILE

#DT2W
DT2W=`grep "item.1.5" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo "write /sys/android_touch/doubletap2wake " $DT2W >> $CONFIGFILE

#Camera launch gestures
CAMGEST=`grep "item.2.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo "write /sys/android_touch/camera_gesture " $CAMGEST >> $CONFIGFILE

#S2S
S2S=`grep selected.0 /tmp/aroma/s2s.prop | cut -d '=' -f2`
if [ $S2S = 2 ]; then
  echo "write /sys/android_touch/sweep2sleep 1" >> $CONFIGFILE
elif [ $S2S = 3 ]; then
  echo "write /sys/android_touch/sweep2sleep 2" >> $CONFIGFILE
elif [ $S2S = 4 ]; then
  echo "write /sys/android_touch/sweep2sleep 3" >> $CONFIGFILE
else
  echo "write /sys/android_touch/sweep2sleep 0" >> $CONFIGFILE
fi

#WG vibration strength
VIBSTRENGTH=`grep "item.2.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
if [ $VIBSTRENGTH = 0 ]; then
  echo "write /sys/android_touch/vib_strength 0" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#fsync
FSYNC=`grep "item.0.1" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $FSYNC = 1 ]; then
  echo "write /sys/module/sync/parameters/fsync_enabled 0" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#charge led
CHGLED=`grep "item.0.2" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $CHGLED = 1 ]; then
  echo "write /sys/class/leds/charging/trigger battery-charging" >> $CONFIGFILE
  echo "write /sys/class/leds/charging/max_brightness 1" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#USB Fastcharge
FC=`grep "item.0.3" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $FC = 1 ]; then
  echo "write /sys/kernel/fast_charge/force_fast_charge 1" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#Key presses during suspend
KEYPRESS=`grep "item.0.4" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $KEYPRESS = 1 ]; then
  echo "write /sys/module/input_core/parameters/disable_release_keys 1" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#color profiles
COLOR=`grep selected.0 /tmp/aroma/color.prop | cut -d '=' -f2`
if [ $COLOR = 2 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"230 232 255\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 274" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 247" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 268" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 0" >> $CONFIGFILE
elif [ $COLOR = 3 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"250 250 255\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 243" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 250" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 255" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 1515" >> $CONFIGFILE
elif [ $COLOR = 4 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal  \"232 228 255\"" >> $CONFIGFILE 
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 249" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 253" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 255" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 1515" >> $CONFIGFILE
elif [ $COLOR = 5 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"230 222 252\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 263" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 262" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 247" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 0" >> $CONFIGFILE
elif [ $COLOR = 6 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"230 232 255\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 278" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 272" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 242" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 0" >> $CONFIGFILE
elif [ $COLOR = 7 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"237 235 255\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 273" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 247" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 242" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 0" >> $CONFIGFILE
elif [ $COLOR = 8 ]; then
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal \"230 232 255\"" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_sat 263" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_val 252" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_cont 242" >> $CONFIGFILE
  echo "write /sys/devices/platform/kcal_ctrl.0/kcal_hue 0" >> $CONFIGFILE
fi

echo "on property:sys.boot_completed=1" >> $CONFIGFILE
echo "" >> $CONFIGFILE

#i/o scheduler
SCHED=`grep selected.1 /tmp/aroma/disk.prop | cut -d '=' -f2`
if [ $SCHED = 1 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler cfq"  >> $CONFIGFILE
elif [ $SCHED = 2 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler deadline"  >> $CONFIGFILE
elif [ $SCHED = 3 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler bfq"  >> $CONFIGFILE
elif [ $SCHED = 4 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler noop"  >> $CONFIGFILE
elif [ $SCHED = 5 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler fiops"  >> $CONFIGFILE
elif [ $SCHED = 6 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler sio"  >> $CONFIGFILE
elif [ $SCHED = 7 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler zen"  >> $CONFIGFILE
fi

#Readahead buffer size
READAHEAD=`grep selected.2 /tmp/aroma/disk.prop | cut -d '=' -f2`
if [ $READAHEAD = 1 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 128" >> $CONFIGFILE
elif [ $READAHEAD = 2 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 256" >> $CONFIGFILE
elif [ $READAHEAD = 3 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 512" >> $CONFIGFILE
elif [ $READAHEAD = 4 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 1024" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE


echo -e "##### Reinstall Options #####" > $BACKUP
echo -e "# These settings are only applied if you run the express installer" >> $BACKUP

#Maximum CPU freqs
CPU0=$(cat /tmp/aroma/cpu.prop | cut -d '=' -f2)
echo -e "\n\n##### Max CPU Frequncies #####" >> $BACKUP
echo -e "# 1=3033MHz 2=2957MHz" >> $BACKUP
echo -e "# 3=2880MHz 4=2803MHz" >> $BACKUP
echo -e "# 5=2726MHz 6=2650MHz" >> $BACKUP
echo -e "# 7=2573MHz 8=2266MHz" >> $BACKUP
echo -e "# 9=1958MHz 10=1728MHz" >> $BACKUP
echo -e "# 11=1574MHz\n" >> $BACKUP
echo "CPU0=$CPU0" >> $BACKUP;

